package org.openstreetmap.josm.plugins.lanetool;

import org.openstreetmap.josm.data.osm.DataSet;
import org.openstreetmap.josm.gui.MapFrame;
import org.openstreetmap.josm.gui.MapView;
import org.openstreetmap.josm.gui.layer.Layer;
import org.openstreetmap.josm.plugins.Plugin;
import org.openstreetmap.josm.plugins.PluginInformation;
import org.openstreetmap.josm.plugins.lanetool.data.LanesData;
import org.openstreetmap.josm.plugins.lanetool.view.LanesDialog;
import org.openstreetmap.josm.gui.MapView.LayerChangeListener;

/**
 * A lane_group relation editing tool for JOSM
 *
 * @author Tobias Knerr
 */
public class LaneTool extends Plugin implements LayerChangeListener {

	private LanesDialog laneDialog;
	private LanesData laneData;
	
    /** creates the plugin */
    public LaneTool(PluginInformation info) {
		super(info);
    	
    	laneData = new LanesData();	
    	DataSet.selListeners.add(laneData);
    	
    	laneDialog = new LanesDialog(laneData);    
    }

    @Override
    public void mapFrameInitialized(MapFrame oldFrame, MapFrame newFrame) {
        if (newFrame != null) {            
            newFrame.addToggleDialog(laneDialog);
            MapView.addLayerChangeListener(this);
        } else
        	MapView.removeLayerChangeListener(this);

//        LinkedList<UploadHook> hooks = ((UploadAction) Main.main.menu.upload).uploadHooks;
//        Iterator<UploadHook> hooksIt = hooks.iterator();
//        while (hooksIt.hasNext()) {
//            if (hooksIt.next() instanceof ValidateUploadHook) {
//                if (newFrame == null)
//                    hooksIt.remove();
//                break;
//            }
//        }
//        if (newFrame != null)
//            hooks.add(0, new ValidateUploadHook(this));
    }

    public void activeLayerChange(Layer oldLayer, Layer newLayer) {
    }

    public void layerAdded(Layer newLayer) {
    }

    public void layerRemoved(Layer oldLayer) {
    }
}
