package org.openstreetmap.josm.plugins.lanetool.data;

import java.util.Observer;

import org.openstreetmap.josm.data.osm.OsmPrimitive;

public interface Lane {

	public OsmPrimitive getOsmObject();
	
	public String getLaneType();
	
	public void setLaneType(String value);
	
	public boolean isSelected();
	
	public void select();
	
	public void addToSelection();
	
	public void removeFromSelection();

	public Direction getDirection();
	
	public void setDirection(Direction newDirection);
	
	public RelationLane addSibling(String laneType, boolean toRight);
	
	/**
	 * removes this lane from its lane group and the dataset
	 */
	public void delete();

	public void addObserver(Observer o);
	
}
