package org.openstreetmap.josm.plugins.lanetool.data;

import org.openstreetmap.josm.Main;
import org.openstreetmap.josm.command.ChangeCommand;
import org.openstreetmap.josm.command.Command;
import org.openstreetmap.josm.data.osm.Way;

public class WayLane extends AbstractLane<Way> {
	
	WayLane(Way osmObject, LaneGroup parent) {
		super(osmObject, parent);
	}
	
	@Override
	protected void setTag(String key, String value) {
		
		Way oldWay = new Way();
		oldWay.cloneFrom(osmObject);
		
		osmObject.put(key, value);
		
		Command command = new ChangeCommand(oldWay, osmObject);
		command.executeCommand();
		Main.main.getCurrentDataSet().fireSelectionChanged();
		
		setChanged();
		notifyObservers();
	}
	
	@Override
	protected void removeTag(String key) {
		
		Way oldWay = new Way();
		oldWay.cloneFrom(osmObject);
		
		osmObject.remove(key);
		
		Command command = new ChangeCommand(oldWay, osmObject);
		command.executeCommand();
		Main.main.getCurrentDataSet().fireSelectionChanged();
		
		setChanged();
		notifyObservers();
	}

}
