package org.openstreetmap.josm.plugins.lanetool.view.util;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;

public final class ImageUtil {
	
	/** private constructor to prevent instantiation */
	private ImageUtil() {}

	public static void fillWithImage(Image image, Graphics g, Rectangle rect) {
		
		fillWithImage(image, g,
				rect.x, rect.y,
				rect.x + rect.width, rect.y + rect.height);
		
	}

	private static void fillWithImage(Image image, Graphics g, int x1, int y1, int x2, int y2) {
		
		for (int xPos = x1; xPos < x2; xPos += image.getWidth(null)) {
			for (int yPos = y1; yPos < y2; yPos += image.getHeight(null)) {
				int xRight = Math.min(xPos + image.getWidth(null), x2);
				int yRight = Math.min(yPos + image.getHeight(null), y2);
				g.drawImage(image, xPos, yPos, xRight - xPos, yRight - yPos, null);
			}		
		}
		
	}
}
